package wipi_book_io;

import org.kwis.msp.lcdui.*;
import org.kwis.msp.io.*;
import org.kwis.msp.lwc.*;
import java.io.*;
import java.util.*;

import java.lang.Runtime;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ExplorerTest extends Jlet  implements CommandListener , ImageObserver ,ActionListener {


    private int ACCESSAREA = FileSystem.PRIVATE_ACCESS ;
    public String CURRENTDIR = "/";


    MyCard lists = null ;

    private Image img_mkdir=null ;
    private Image img_newfile=null ;
    private Image img_del=null ;
    private Image img_rename=null ;
    private Image img_upper=null ;
    private Image img_select=null ;
    private Image img_info=null ;
    private Image img_change=null ;
    private Image img_file=null ;
    private Image img_dir=null ;

    private Command cmd_mkdir=null ;
    private Command cmd_newfile=null ;
    private Command cmd_del=null ;
    private Command cmd_rename=null ;
    private Command cmd_upper=null ;
    private Command cmd_select=null ;
    private Command cmd_info=null ;
    private Command cmd_list=null ;

    ShellComponent sh =null ;
    CommandBarComponent cmdBar = null ;
    MyCard card = null ;
    TextFieldComponent textfield = null;
    TextBoxComponent textbox  = null  ;
    ButtonComponent btn = null ;


    public ExplorerTest() {
    }
    protected void destroyApp(boolean parm1){
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
    }
    protected void startApp(String[] parm1) {
        AnnunciatorComponent m_anc = new AnnunciatorComponent(false) ;
        m_anc.show();
        loadImages();
        draw();
    }

    /**
     * Card  stack ִ´.
     */
    private void draw(){
        Display dis = Display.getDefaultDisplay();
        card = new MyCard();
        dis.pushCard(card);
    }

    private void loadImages(){
        try
        {
            img_mkdir = Image.createImage("mkdir.png");
//            img_rmdir = Image.createImage("rmdir.png");
            img_newfile = Image.createImage("newfile.png");
            img_del = Image.createImage("delfile.png");
            img_rename = Image.createImage("rename.png");
            img_upper = Image.createImage("upper.png");
            img_select = Image.createImage("select.png");
            img_info   = Image.createImage("info.png");
            img_change   = Image.createImage("chgarea.png");
            img_file   = Image.createImage("file.png");
            img_dir   = Image.loadImage("dir.png", this);

        }
        catch(Exception e){}
    }

    /**
     * Ʈ о δ.
     */
    private void load(){
        sh = new ShellComponent();
        sh.setTitle("MOBILE-EXPLORER");

        cmdBar = new CommandBarComponent();
        cmdBar.addCommand(cmd_mkdir = new Command("", img_mkdir, null));
//        cmdBar.addCommand(cmd_rmdir = new Command("", img_rmdir, null));
        cmdBar.addCommand(cmd_newfile = new Command("ϸ", img_newfile, null));
        cmdBar.addCommand(cmd_del = new Command("", img_del, null));
        cmdBar.addCommand(cmd_rename = new Command("̸ٲٱ", img_rename, null));
        cmdBar.addCommand(cmd_select = new Command(" ", img_select, null));
        cmdBar.addCommand(cmd_upper = new Command(" ", img_upper, null));
        cmdBar.addCommand(cmd_info = new Command("", img_info, null));
        cmdBar.addCommand(cmd_list = new Command("Ʈ", img_change, null));
        cmdBar.setCommandListener(this, null);

        sh.setCommand(cmdBar,false);
        sh.show();
    }

    /**
     *  , 丮 ߰ â . 1 : 丮 ,  2 :  , 3 :̸ ٲٱ
     * @param which
     */
    private void loadMkdir(int which){
        sh = new ShellComponent();
        sh.setTitle("MOBILE-EXPLORER");
        FormComponent frm = new FormComponent();
        if( which == 1 ){
            frm.addComponent(new LabelComponent("丮̸"));
            textfield =   new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        }else if( which == 2 ){
            frm.addComponent(new LabelComponent("̸"));
            textfield =   new TextFieldComponent("",TextComponent.CONSTRAINT_ANY);
        }else if( which == 3 ){
           frm.addComponent(new LabelComponent("ٲ  ̸"));
            textfield =   new TextFieldComponent(card.scroll.SelectPressed().title,TextComponent.CONSTRAINT_ANY);
        }
        frm.addComponent(textfield);
        if(which == 2) {
            frm.addComponent(new LabelComponent("ϳ"));
            textbox = new TextBoxComponent("",TextComponent.CONSTRAINT_ANY,50);
            frm.addComponent(textbox);
        }
        else if(which == 3) {
            frm.addComponent(new LabelComponent("ٲ ̸"));
            textbox = new TextBoxComponent("",TextComponent.CONSTRAINT_ANY);
            frm.addComponent(textbox);
        }

        sh.addComponent(frm);
        if(which ==1) btn = new ButtonComponent("丮",null);
        else if(which == 2 )  btn = new ButtonComponent("ϸ",null);
        else if(which == 3 )  btn = new ButtonComponent("̸ٲٱ",null);

        btn.setActionListener(this,null);
        sh.setCommand(btn, false);
        sh.show();
    }

   public  void action(Component p0, Object p1){
        ButtonComponent _btn = (ButtonComponent)   p0;
        if(_btn.getString().indexOf("丮") != -1){
            String dirname = textfield.getString();
            try{
                dirname = CURRENTDIR+"/"+dirname;
                FileSystem.mkdir(dirname);
            }catch(Exception e){}
        }
        else if(_btn.getString().indexOf("") != -1){
            String filename = textfield.getString();
            try{
                filename = CURRENTDIR+"/"+filename;
                File file = new File(filename,File.WRITE);
                file.write(textbox.getString().getBytes());
            }catch(Exception e){}
        }
        else if(_btn.getString().indexOf("̸ٲٱ") != -1 ){
            try{
                FileSystem.rename(textfield.getString(), textbox.getString());
            }catch(Exception e){ }
        }

        load();
        draw();
        card.scroll.ItemChanged(card.getListItems());
        card.m_currentmode=card.MODE_DIR ;
        card.repaint();
    }


    /**
     * ̹  Ҹ ȣȴ.
     * @param p0
     * @param p1
     */
    public void notify(Image p0, int p1){
        load();
    }

    public void commandAction(Command c, int type, Object obj){
        System.out.println("aaa"+c.getString() + "type = "+ type);

        // 
        if(c.equals(cmd_mkdir) && type == 2 ) {
            if(card.m_currentmode != card.MODE_DIR ){
                card.scroll.ItemChanged(card.scroll.getItemArray("Ʈ ¿  մϴ. "+
                               "Ʈ  ̵Ͻʽÿ ",card.getWidth() -10 , null));
                card.scroll.setSelectionMode(false);
            }else{
                loadMkdir(1);
                card.m_currentmode = card.MODE_MKDIR;
                card.repaint();
            }
            return  ;
        }
        // 
        if(c.equals(cmd_newfile) && type == 2 ) {
            if(card.m_currentmode != card.MODE_DIR ){
                card.scroll.ItemChanged(card.scroll.getItemArray("Ʈ ¿  մϴ. "+
                               "Ʈ  ̵Ͻʽÿ ",card.getWidth() -10 , null));
                card.scroll.setSelectionMode(false);
            }else{
                loadMkdir(2);
                card.m_currentmode = card.MODE_NEWFILE;
                card.repaint();
            }
        }

        //ϱ
        if(c.equals(cmd_del) && type == 2 ) {
            if(card.m_currentmode != card.MODE_DIR ){
                card.scroll.ItemChanged(card.scroll.getItemArray("Ʈ ¿  մϴ. "+
                               "Ʈ  ̵Ͻʽÿ ",card.getWidth() -10 , null));
                card.scroll.setSelectionMode(false);
            }else{
                String filename = CURRENTDIR+"/"+card.scroll.SelectPressed().title;
                try{
                    if(FileSystem.isDirectory(filename)){
                        FileSystem.rmdir(filename);
                    }else {
                        FileSystem.remove(filename);
                    }
                }catch(Exception e){
                    card.scroll.ItemChanged(card.scroll.getItemArray(" ߻Ͽϴ.",card.getWidth() -10 , null));
                    card.scroll.setSelectionMode(false);
                    card.repaint();
                    return ;
                }
                card.m_currentmode = card.MODE_MKDIR;
                CURRENTDIR ="/";
                card.scroll.ItemChanged(card.getListItems());
                card.repaint();
            }
            return  ;
        }


        //̸ ٲٱ
        if(c.equals(cmd_rename) && type == 2 ) {
            if(card.m_currentmode != card.MODE_DIR ){
                card.scroll.ItemChanged(card.scroll.getItemArray("Ʈ ¿  մϴ. "+
                               "Ʈ  ̵Ͻʽÿ ",card.getWidth() -10 , null));
                card.scroll.setSelectionMode(false);
            }else{
                loadMkdir(3);
                card.m_currentmode = card.MODE_NEWFILE;
                card.repaint();
            }
            return  ;
        }

        //Ʈ 
        if(c.equals(cmd_list) && type == 2 ) {
            card.m_currentmode = card.MODE_DIR;
            card.scroll.ItemChanged(card.getListItems());
            card.scroll.setSelectionMode(true);
            card.repaint();
            return ;
        }
        //
        if(c.equals(cmd_info) && type == 2 ) {
            int space = FileSystem.available();
            int total = (int) Runtime.getRuntime().totalMemory();
            int freemem = (int) Runtime.getRuntime().freeMemory();
            card.scroll.ItemChanged(card.scroll.getItemArray("  "+space +
                         " ŭ 밡 մϴ , ޸𸮴  "+
                         total+"  "+freemem+" ŭ 밡մϴ.",card.getWidth() -10 , null));
            card.m_currentmode = card.MODE_INFO;
            card.repaint();
            return ;
        }

        //
        if(c.equals(cmd_upper) && type == 2 ) {
            if(card.m_currentmode == card.MODE_FILEVIEW) {
                card.m_currentmode = card.MODE_DIR ;
                card.scroll.ItemChanged(card.getListItems());
                card.scroll.setSelectionMode(true);
                card.repaint();
                return ;
            }
            if(card.m_currentmode != card.MODE_DIR){
                card.scroll.ItemChanged(card.scroll.getItemArray("Ʈ ¿  մϴ. "+
                               "Ʈ  ̵Ͻʽÿ ",card.getWidth() -10 , null));
            }else{
                int index  = CURRENTDIR.indexOf("/");
                if(index < 1 )     CURRENTDIR = "/" ;
                else       CURRENTDIR= CURRENTDIR.substring(0,index-1);
                card.scroll.ItemChanged(card.getListItems());
                card.scroll.setSelectionMode(true);
            }
            card.repaint();
            return ;
        }
        //
        if(c.equals(cmd_select) && type == 2 ) {
            if(card.m_currentmode == card.MODE_FILEVIEW) {
                card.m_currentmode = card.MODE_DIR ;
                card.scroll.ItemChanged(card.getListItems());
                card.scroll.setSelectionMode(true);
                card.repaint();
                return ;
            }
            if(card.m_currentmode != card.MODE_DIR ){
                card.scroll.ItemChanged(card.scroll.getItemArray("Ʈ ¿  մϴ. "+
                               "Ʈ  ̵Ͻʽÿ ",card.getWidth() -10 , null));
            }else{
                String filename = card.scroll.SelectPressed().title ;
                //丮̸
                try{
                    if(FileSystem.isDirectory(filename)){
                        CURRENTDIR =  filename ;
                        card.scroll.ItemChanged(card.getListItems());
                    }
                    //̸
                    else {
                        File file = new File(CURRENTDIR+"/"+filename, File.READ_ONLY);

                        int length = file.sizeOf();
                        byte[] filebytes = null ;
                        if(length > 500){
                            int time = FileSystem.getCreationTime(CURRENTDIR+"/"+filename);
                            filebytes = (" ̰ "+ length + " Դϴ.   ð "+time+" Դϴ").getBytes() ;
                        }else {
                            filebytes = new byte[length];
                            DataInputStream dis = file.openDataInputStream();
                            dis.readFully(filebytes);
                        }
                        card.scroll.ItemChanged(card.scroll.getItemArray(new String(filebytes),card.getWidth() -10 , null));
                        card.scroll.setSelectionMode(false);
                        card.m_currentmode = card.MODE_FILEVIEW ;
                    }
                }catch(Exception e){}
            }
            card.repaint();
            return;
        }


    }

    class MyCard extends Card implements  ScrollListAdaptor {

        // ȭ鿡 µǾ 
        public int m_currentmode = 0 ;

        public final int MODE_DIR = 0 ;
        public final int MODE_INFO = 1 ;
        public final int MODE_FILEVIEW = 2 ;
        public final int MODE_MKDIR = 3 ;
        public final int MODE_RMDIR = 4 ;
        public final int MODE_NEWFILE = 5 ;
        public final int MODE_DELFILE = 6 ;

        ScrollList scroll = null ;
        ListItem[] m_listsItem = null ;

        public MyCard(){
            super(true);
            ListItem[] items = getListItems() ;
            scroll = new ScrollList(this,0,20,getWidth(),getHeight()-60 , items);
            scroll.setSelectionMode(true);
            scroll.setMarqueActive(false);
        }

        /**
         * 庰  Ʈ  ´.
         * @param mode
         * @return
         */
        public  ListItem[] getListItems(){
            ListItem[]   m_listsItem = null;
            try{
                Vector files = FileSystem.list(CURRENTDIR,FileSystem.PRIVATE_ACCESS);
                m_listsItem = new ListItem[files.size()];
                for(int i = 0 ; i <  files.size() ; i++ ){
                    String filename  = (String) files.elementAt(i);
                    if(FileSystem.isDirectory(filename,ACCESSAREA))
                        m_listsItem[i] = new ListItem(img_dir,img_dir,filename,"dir",false);
                    else
                        m_listsItem[i] = new ListItem(img_file,img_file,filename,"file",false);

                }
            } catch(Exception e){};
            return m_listsItem;
        }



        /**
         * ScrollList  ׸.
         * @param g
         */
        public void paint(Graphics g){
            System.out.println("paint");
            // ʱ⿡ ع ׸ϴ.
            g.setColor(0xFFFFFF);
            g.fillRect(0, 20, getWidth(), getHeight()-60 );
            g.setColor(0);
            switch(m_currentmode){
                case MODE_DIR:
                case MODE_FILEVIEW:
                case MODE_INFO:
                case MODE_RMDIR:
                case MODE_DELFILE:
                    scroll.drawList(g);
                    break ;
                case MODE_MKDIR :
                    break ;
            }
        }

        public boolean  keyNotify(int type, int key){
            if(type == EventQueue.POINT_RELEASED){
                switch(Display.getGameAction(key)){
                    case EventQueue.UP :
                        scroll.moveUp();
                            break;
                    case EventQueue.DOWN :
                        scroll.moveDown();
                            break;
                    case EventQueue.RIGHT :
                        scroll.moveRight();
                            break;
                    case EventQueue.LEFT :
                        scroll.moveLeft();
                            break;
                    case EventQueue.FIRE :
//                        scroll.SelectPressed();
                            break;
                    case EventQueue.CLEAR :
                            break;
                    case EventQueue.SOFT1 :
                        ListItem listitem = scroll.SelectPressed();
                        listitem.isActive = !listitem.isActive ;
                         break;
                }
                repaint();
            }
            return false ;
        }

        public void drawScrollList(){
            repaint();
        }

    }

}