package wipi_book_io;

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.* ;
import org.kwis.msp.io.*;
import java.io.*;


public class FileTest extends Jlet implements ActionListener , ChangeListener {


    ShellComponent sh = null ;
    MyComboComponent cmc = null ;
    TextFieldComponent textfield1 = null ;
    TextBoxComponent textbox2 = null ;
    /**
     * area  0 : PRIVATE , 1 : SHARED , 2 : SYSTEM
     */
    int area =  0;

    public FileTest() {
    }
    protected void destroyApp(boolean parm1){
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
    }
    protected void startApp(String[] parm1) {
        AnnunciatorComponent m_anc = new AnnunciatorComponent(false) ;
        m_anc.show();
        load();
    }

    /**
     * ȭ Ѵ.
     */
    private void load(){
        sh = new ShellComponent();
        sh.setTitle("FILE TEST");
        FormComponent frm = new FormComponent();
        textfield1 = new TextFieldComponent("",TextComponent.CONSTRAINT_ANY) ;
        textbox2 = new TextBoxComponent("",TextComponent.CONSTRAINT_ANY, 50) ;
        frm.addComponent(new LabelComponent("̸",(Image)null));
        frm.addComponent(textfield1);
        frm.addComponent(new LabelComponent("",(Image)null));
        frm.addComponent(textbox2);

        cmc = new MyComboComponent();
        cmc.append("PRIVATE");
        cmc.append("SHARED");
        cmc.append("SYSTEM");
        cmc.setChangeListener(this, null);
        frm.addComponent(cmc);


        sh.addComponent(frm);
        ButtonComponent btn = new ButtonComponent("", null);
        btn.setActionListener(this,null);
        sh.setCommand(btn,false);
        sh.validate();
        sh.show();
    }


    /**
     * ư  ȣǴ ޼ҵ
     * @param cmp
     * @param o
     */
    public void action(Component cmp, Object o){
        int area = FileSystem.PRIVATE_ACCESS;
        switch(area){
            case 0 :area = FileSystem.PRIVATE_ACCESS;
                    break ;
            case 1 :area = FileSystem.SHARED_ACCESS;
                    break ;
            case 2 :area = FileSystem.SYSTEM_ACCESS;
                    break ;
        }
        String filename = textfield1.getString();

        File file =  null ;
        DataOutputStream dos = null;
        try {
            file = new File(filename,File.READ_WRITE, area);
            dos =  new DataOutputStream(file.openDataOutputStream());
            file.seek(file.sizeOf()/2);
            dos.write(textbox2.getString().getBytes());
        }catch(IOException e){}
//        file.write(textbox2.getString().getBytes());

    }

    /**
     * ޺ ٲ  ȣǴ ޼ҵ
     * @param cmp
     * @param o
     */
    public void changed(Component cmp, Object o){
        if(cmp.equals(cmc)){
            if(cmc.getSelectedIndex() == 0) area = 0 ;
            else if(cmc.getSelectedIndex() == 1) area = 1 ;
            else if(cmc.getSelectedIndex() == 2) area = 2 ;
        }
    }

    /**
     * ̰ 15 ޺ڽ .
     */
    class MyComboComponent extends ComboComponent{
        public int height = 15 ;
        public MyComboComponent(){
            super();
        }

        public int getPreferredHeight(int w){
            return  height ;
        }
    }
}