/**
 * <p>Title: DataInputStream  Stream</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import java.io.InputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.EOFException;
import org.kwis.msf.io.*;
//import java.net.Socket;
import java.io.InterruptedIOException;

public class ReadStream extends DataInputStream
{
  /**
   * <code>ReadStream</code> .
   *   Ʈ Ѵ
   * <code>in</code>
   *
   * @param  in   input stream.
   */
  public ReadStream(InputStream in)
  {
    super(in);
  }

  /**
   * 2 byte ũ ڿ д´
   * <p>
   * @return     String ڿ
   * @exception  EOFException  if this input stream reaches the end before
   *               reading two bytes.
   * @exception  IOException   if an I/O error occurs.
   * @see        java.io.FilterInputStream#in
   */
  public final String readString() throws IOException
  {
    int size = readShort();

    if (size < 0) throw new EOFException();

    byte[] content = new byte[size];

    read(content, 0, size);
    return new String(content);
  }

}